#include "Object_Trade.mqh"

struct OBJECT_TREND : public OBJECT_TRADE
{
  long TicketClose;

  double PriceOpen;
  double PriceClose;

  datetime TimeOpen;
  datetime TimeClose;

  bool Set( string sName, const ulong Chart = 0 )
  {
    const bool Res = this.OBJECT_TRADE::Set(sName);

    if (Res)
    {
      this.PriceOpen = ::ObjectGetDouble(Chart, sName, OBJPROP_PRICE);
      this.PriceClose = ::ObjectGetDouble(Chart, sName, OBJPROP_PRICE, 1);

      this.TimeOpen = (datetime)::ObjectGetInteger(Chart, sName, OBJPROP_TIME);
      this.TimeClose = (datetime)::ObjectGetInteger(Chart, sName, OBJPROP_TIME, 1);

      this.TicketClose = (int)this.StringBetween(sName, " -> #", ", ");

      this.Name = sName;
    }

    return(Res);
  }

  void Get( ENUM_DEAL_REASON &eCloseReason, double &dProfit, string &sSymbol ) const
  {
    string sName = this.Name.Get();

    const string StrTmp = this.StringBetween(sName, NULL, "profit ");
    eCloseReason = (StrTmp == "SL, ") ? DEAL_REASON_SL : ((StrTmp == "TP, ") ? DEAL_REASON_TP : DEAL_REASON_CLIENT);

    string StrProfit = this.StringBetween(sName, NULL, ", ");
    ::StringReplace(StrProfit, " ", NULL);

    dProfit = (double)StrProfit;
    sSymbol = sName;

    return;
  }

#define TOSTRING(A) #A + " = " + (string)(this.A) + "\n"
  string ToString( void ) const
  {
    return(this.OBJECT_TRADE::ToString() + TOSTRING(TicketClose) + TOSTRING(PriceOpen) + TOSTRING(PriceClose) + TOSTRING(TimeOpen) + TOSTRING(TimeClose));
  }
#undef TOSTRING
};